// Equation.cpp : Implementation of CEquation

#include "stdafx.h"
#include "Equation.h"
#include <math.h>
 

// CEquation

STDMETHODIMP CEquation::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IEquation
	};

	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CEquation::Solve(FLOAT a, FLOAT b, FLOAT c, FLOATvec* out)
{
	
	if (a==0.0) { //rownanie liniowe
		if(b==0.0) { //sprzeczne lub nieoznaczone
			if (c==0.0)
				return Error("Rownanie nieoznaczone", IID_IEquation, E_FAIL);
			(*out).size=0;
			(*out).results=NULL;
		} else { // 1 rozwiazanie
			(*out).size=1;
			(*out).results=(FLOAT*)CoTaskMemAlloc((*out).size*sizeof(FLOAT));
			if ((*out).results==NULL)
				return Error("Blad alokacji", IID_IEquation, E_OUTOFMEMORY);
			(*out).results[0]=-c/b;
		}
	} else {
		FLOAT delta;
		delta=b*b-4*a*c;
		if (delta<0.0){//0 wynikow
			(*out).size=0;
			(*out).results=NULL;
		} else if (delta==0.0){ //1 wynik
			(*out).size=1;
			(*out).results=(FLOAT*)CoTaskMemAlloc((*out).size*sizeof(FLOAT));
			if ((*out).results==NULL)
				return Error("Blad alokacji", IID_IEquation, E_OUTOFMEMORY);
			(*out).results[0]=-b/(2*a);
		} else { //2 wyniki
			(*out).size=2;
			(*out).results=(FLOAT*)CoTaskMemAlloc((*out).size*sizeof(FLOAT));
			if ((*out).results==NULL)
				return Error("Blad alokacji", IID_IEquation, E_OUTOFMEMORY);
			(*out).results[0]=(-b-sqrt(delta))/(2*a);
			(*out).results[1]=(-b+sqrt(delta))/(2*a);
		}
	}

	return S_OK;
}
